config/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path
from django.views import defaults as default_views
from django.views.generic import TemplateView
from drf_spectacular.views import SpectacularAPIView, SpectacularSwaggerView
from rest_framework.authtoken.views import obtain_auth_token

urlpatterns = [
    path("", TemplateView.as_view(template_name="pages/home.html"), name="home"),
    path(
        "about/", TemplateView.as_view(template_name="pages/about.html"), name="about"
    ),
    # Django Admin, use {% url 'admin:index' %}
    path(settings.ADMIN_URL, admin.site.urls),
    # Languages selections
    path("i18n/", include("django.conf.urls.i18n")),
    # Audit log and activity stream
    path("activity/", include("actstream.urls")),
    # User management
    path("users/", include("diesos.users.urls", namespace="users")),
    path("accounts/", include("allauth.urls")),
    # Diesos Apps
    path("artefacts/", include("diesos.artefacts.urls", namespace="artefacts")),
    path("locations/", include("diesos.locations.urls", namespace="locations")),
    path("scan/", include("diesos.barcodes.urls", namespace="barcodes")),
    path("treatments/", include("diesos.treatments.urls", namespace="treatments")),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

# API URLS
urlpatterns += [
    # API base url
    path("api/", include("config.api_router")),
    # DRF auth token
    path("auth-token/", obtain_auth_token),
    path("api/schema/", SpectacularAPIView.as_view(), name="api-schema"),
    path(
        "api/docs/",
        SpectacularSwaggerView.as_view(url_name="api-schema"),
        name="api-docs",
    ),
]

if settings.DEBUG:
    # This allows the error pages to be debugged during development, just visit
    # these url in browser to see how these error pages look like.
    urlpatterns += [
        path(
            "400/",
            default_views.bad_request,
            kwargs={"exception": Exception("Bad Request!")},
        ),
        path(
            "403/",
            default_views.permission_denied,
            kwargs={"exception": Exception("Permission Denied")},
        ),
        path(
            "404/",
            default_views.page_not_found,
            kwargs={"exception": Exception("Page not Found")},
        ),
        path("500/", default_views.server_error),
    ]
    if "debug_toolbar" in settings.INSTALLED_APPS:
        import debug_toolbar

        urlpatterns = [path("__debug__/", include(debug_toolbar.urls))] + urlpatterns

diesos/artefacts/urls.py
from django.urls import path

from diesos.artefacts import views

app_name = "artefacts"

urlpatterns = [
    path("", views.ArtefactListView.as_view(), name="list"),
    path("add", views.ArtefactCreateView.as_view(), name="add"),
    path("<int:pk>/change", views.ArtefactUpdateView.as_view(), name="change"),
    path("<int:pk>/delete", views.ArtefactDeleteView.as_view(), name="delete"),
    path("<int:pk>", views.ArtefactDetailView.as_view(), name="view"),
    path("<int:pk>/scan", views.ArtefactScanView.as_view(), name="scan"),
    path(
        "<int:pk>/scan/finish",
        views.finish_stabilization_measures,
        name="finish-stabilization",
    ),
    path(
        "<int:pk>/scan/start/<int:processing_line_id>",
        views.start_stabilization_measures,
        name="start-stabilization",
    ),
    path("type", views.ArtefactTypeListView.as_view(), name="list-type"),
    path("type/add", views.ArtefactTypeCreateView.as_view(), name="add-type"),
    path(
        "type/<int:pk>/change",
        views.ArtefactTypeUpdateView.as_view(),
        name="change-type",
    ),
    path(
        "type/<int:pk>/delete",
        views.ArtefactTypeDeleteView.as_view(),
        name="delete-type",
    ),
    path(
        "type/<int:pk>/undelete",
        views.undelete_artefact_type,
        name="undelete-type",
    ),
    path("type/save-type-ordering", views.save_new_ordering, name="save-type-ordering"),
    path(
        "<int:pk>/take-picture",
        views.ArtefactTakePicture.as_view(),
        name="take-picture",
    ),
    path("damage/group", views.DamageGroupListView.as_view(), name="list-damage-group"),
    path(
        "damage/group/add",
        views.DamageGroupCreateView.as_view(),
        name="add-damage-group",
    ),
    path(
        "damage/group/<int:pk>/delete",
        views.DamageGroupDeleteView.as_view(),
        name="delete-damage-group",
    ),
    path(
        "damage/group/<int:pk>/undelete",
        views.undelete_damage_group,
        name="undelete-damage-group",
    ),
    path(
        "damage/group/<int:pk>/change",
        views.DamageGroupUpdateView.as_view(),
        name="change-damage-group",
    ),
    path("damage/type", views.TypeOfDamageListView.as_view(), name="list-damage-type"),
    path(
        "damage/type/add",
        views.TypeOfDamageCreateView.as_view(),
        name="add-damage-type",
    ),
    path(
        "damage/type/<int:pk>/delete",
        views.TypeOfDamageDeleteView.as_view(),
        name="delete-damage-type",
    ),
    path(
        "damage/type/<int:pk>/undelete",
        views.undelete_type_of_damage,
        name="undelete-damage-type",
    ),
    path(
        "damage/type/<int:pk>/change",
        views.TypeOfDamageUpdateView.as_view(),
        name="change-damage-type",
    ),
    path(
        "<int:pk>/damage-assessment",
        views.DamageAssessmentUpdateView.as_view(),
        name="change-damage",
    ),
    path("priority", views.PriorityLevelListView.as_view(), name="priority-level"),
    path(
        "priority/<int:pk>/change",
        views.PriorityLevelUpdateView.as_view(),
        name="change-priority",
    ),
    path(
        "<int:pk>/stabilization",
        views.StabilizationMeasureUpdateView.as_view(),
        name="change-stabilization-measure",
    ),
    path(
        "<int:pk>/stabilization/delete/<int:treatment_type_id>",
        views.delete_treatment_type,
        name="delete-treatment-type",
    ),
    path(
        "<int:pk>/stabilization/save-treatment-type-ordering",
        views.save_treatment_type_ordering,
        name="save-treatment-type-ordering",
    ),
    path(
        "existing-collection/import", views.UploadCsvView.as_view(), name="import-file"
    ),
    path(
        "existing-collection/headers/edit",
        views.FileHeaderEditView.as_view(),
        name="header-edit-existing-collection",
    ),
    path(
        "existing-collection/map",
        views.CsvMapperView.as_view(),
        name="map-existing-collection",
    ),
    path(
        "existing-collection/map/complex",
        views.ComplexMapperView.as_view(),
        name="map-complex-existing-collection",
    ),
    path(
        "existing-collection/<int:pk>",
        views.ExistingCollectionDetailView.as_view(),
        name="view-existing-collection",
    ),
    path(
        "existing-collection",
        views.ExistingCollectionListView.as_view(),
        name="list-existing-collection",
    ),
    path(
        "existing-collection/<int:pk>/delete",
        views.ExistingCollectionDeleteView.as_view(),
        name="delete-existing-collection",
    ),
    path(
        "existing-collection/add",
        views.create_existing_collection,
        name="add-existing-collection",
    ),
]

diesos/barcodes/urls.py
from django.urls import path

from diesos.barcodes.views import scan_barcode, search_barcode, set_scanner

app_name = "barcodes"
urlpatterns = [
    path("", view=scan_barcode, name="read"),
    path("search/", view=search_barcode, name="search"),
    path("set/<str:scanner>", view=set_scanner, name="set"),
]

diesos/users/urls.py
from django.urls import path

from diesos.users.views import user_detail_view, user_redirect_view, user_update_view

app_name = "users"
urlpatterns = [
    path("~redirect/", view=user_redirect_view, name="redirect"),
    path("~update/", view=user_update_view, name="update"),
    path("<str:username>/", view=user_detail_view, name="detail"),
]

diesos/barcodes/views.py
from actstream import action
from django.contrib import messages
from django.contrib.auth.decorators import permission_required
from django.shortcuts import redirect, render
from django.urls import reverse
from django.utils.translation import gettext_lazy as _

from diesos.barcodes.barcode_resolver import resolve_barcode


def set_scanner(request, scanner):
    # We set the user's preference and redirect to the appropriate page
    if scanner == "reader":
        request.session["scanner"] = "reader"
    else:
        request.session["scanner"] = "mobile"

    if request.GET.get("parent_id") and request.GET.get("option"):
        url = (
            reverse("barcodes:read")
            + f'?parent_id={request.GET.get("parent_id")}&option={request.GET.get("option")}'
        )

        return redirect(url)

    return redirect("barcodes:read")


@permission_required("artefacts.view_artefact")
def scan_barcode(request):
    # We check if the user has already scanned a barcode
    scanner = request.session.get("scanner", False)
    if scanner:
        if scanner == "mobile":
            # We display the mobile scanner page
            return render(request, "barcodes/scanner.html")
        else:
            # We display the desktop scanner page
            return render(request, "barcodes/form.html")
    else:
        request.session["scanner"] = "mobile"
        return render(request, "barcodes/scanner.html")


@permission_required("artefacts.view_artefact")
def search_barcode(request):
    barcode = request.GET.get("barcode")
    parent_id = request.GET.get("parent_id")
    option = request.GET.get("option")
    if barcode:
        # Objects matching scan data
        objects = resolve_barcode(barcode)
        # Objects matching scan data excluding existing collection
        not_existing_collection_objects = [
            obj for obj in objects if obj["object_type"] != "existing_collection"
        ]
        if not objects:
            # This is a new barcode, we can create an object (or it is a scanning error)
            # TODO: add link to buttons as soon as the models are available
            return render(
                request,
                "barcodes/create.html",
                {"barcode": barcode, "parent_id": parent_id, "option": option},
            )
        elif len(objects) == 1 and objects[0]["object_type"] != "existing_collection":
            # This is a single artefact or shortID, we redirect to the object's url
            # TODO: add location (target) to the action
            if "object" in objects[0] and objects[0]["object_type"] == "artefact":
                object_id = objects[0]["object"].id
                return redirect("artefacts:scan", pk=object_id)
            else:
                if "object" in objects[0]:
                    action.send(
                        request.user,
                        verb=_("scanned"),
                        action_object=objects[0]["object"],
                        target=request.processing_line,
                    )
                return redirect(objects[0]["url"])

        elif len(objects) == 1 and objects[0]["object_type"] == "existing_collection":
            # We found only an existingCollection object, we want to create a new artefact from existing info
            messages.success(request, "Existing collection has been found !")
            return render(
                request,
                "barcodes/import.html",
                {"barcode": barcode, "existing_collection": objects[0]["data"]},
            )

        elif len(objects) == 2 and len(not_existing_collection_objects) == 1:
            # We found one object and its existing collection, the user is redirected to the object
            return redirect(not_existing_collection_objects[0]["url"])
        else:
            # We have more than one object, the user have to select the right one
            # We exclude existing_collection objects
            return render(
                request,
                "barcodes/results.html",
                {"barcode": barcode, "objects": not_existing_collection_objects},
            )
    else:
        # We display the form to input a barcode manually or with an external reader
        request.session["scanner"] = "reader"
        return render(request, "barcodes/form.html")

diesos/locations/views.py
from django.contrib import messages
from django.contrib.auth.decorators import permission_required
from django.contrib.auth.mixins import PermissionRequiredMixin
from django.contrib.messages.views import SuccessMessageMixin
from django.shortcuts import redirect
from django.urls import reverse, reverse_lazy
from django.utils.translation import gettext_lazy as _
from django.views.generic import (
    CreateView,
    DeleteView,
    DetailView,
    ListView,
    UpdateView,
)
from treebeard.forms import movenodeform_factory

from .models import Location, LocationType


class LocationTypesListView(PermissionRequiredMixin, ListView):
    permission_required = "locations.view_locationtype"
    model = LocationType


class LocationTypeDetailView(PermissionRequiredMixin, DetailView):
    permission_required = "locations.view_locationtype"
    model = LocationType


class LocationTypeCreateView(PermissionRequiredMixin, SuccessMessageMixin, CreateView):
    permission_required = "locations.add_locationtype"
    model = LocationType
    fields = ["name", "description"]
    success_url = reverse_lazy("locations:list-types")
    success_message = _("The location type <strong>%(name)s</strong> has been created.")


class LocationTypeUpdateView(PermissionRequiredMixin, SuccessMessageMixin, UpdateView):
    permission_required = "locations.change_locationtype"
    model = LocationType
    fields = ["name", "description"]
    success_url = reverse_lazy("locations:list-types")
    success_message = _(
        "The  location type <strong>%(name)s</strong> has been updated."
    )


class LocationTypeDeleteView(PermissionRequiredMixin, DeleteView):
    permission_required = "locations.delete_locationtype"
    model = LocationType

    def get_success_url(self):
        return reverse("locations:list-types")

    def form_valid(self, form):
        response = super().form_valid(form)
        obj = self.object
        url = reverse("locations:undelete-type", kwargs={"pk": obj.pk})
        messages.add_message(
            self.request,
            messages.SUCCESS,
            _(
                f'The location type <strong>{obj.name}</strong> has been \
                    deleted. If it was a mistake, you can <a href="{url}">restore it</a>.'
            ),
        )
        return response


@permission_required("locations.delete_locationtype")
def undelete_location_type(request, pk):
    location_type = LocationType.all_objects.get(pk=pk)
    location_type.undelete()
    messages.add_message(
        request,
        messages.SUCCESS,
        _(
            f"The location type <strong>{location_type.name}</strong> has been restored."
        ),
    )
    return redirect("locations:list-types")


class LocationListView(PermissionRequiredMixin, ListView):
    permission_required = "locations.view_location"
    model = Location


class LocationDetailView(PermissionRequiredMixin, DetailView):
    permission_required = "locations.view_location"
    model = Location


class LocationCreateView(PermissionRequiredMixin, CreateView):
    permission_required = "locations.add_location"
    model = Location
    form_class = movenodeform_factory(Location)


class LocationUpdateView(PermissionRequiredMixin, UpdateView):
    permission_required = "locations.change_location"
    model = Location
    form_class = movenodeform_factory(Location)


class LocationDeleteView(PermissionRequiredMixin, DeleteView):
    permission_required = "locations.delete_location"
    model = Location


@permission_required("locations.delete_location")
def undelete_location(request, pk):
    location = Location.all_objects.get(pk=pk)
    location.undelete()
    messages.add_message(
        request,
        messages.SUCCESS,
        _(f"The location <strong>{location.name}</strong> has been restored."),
    )
    return redirect("locations:list")

diesos/users/api/views.py
from django.contrib.auth import get_user_model
from rest_framework import status
from rest_framework.decorators import action
from rest_framework.mixins import ListModelMixin, RetrieveModelMixin, UpdateModelMixin
from rest_framework.response import Response
from rest_framework.viewsets import GenericViewSet

from .serializers import UserSerializer

User = get_user_model()


class UserViewSet(RetrieveModelMixin, ListModelMixin, UpdateModelMixin, GenericViewSet):
    serializer_class = UserSerializer
    queryset = User.objects.all()
    lookup_field = "username"

    def get_queryset(self, *args, **kwargs):
        assert isinstance(self.request.user.id, int)
        return self.queryset.filter(id=self.request.user.id)

    @action(detail=False)
    def me(self, request):
        serializer = UserSerializer(request.user, context={"request": request})
        return Response(status=status.HTTP_200_OK, data=serializer.data)

diesos/templates/artefacts/artefact_scan.html
{% extends "base.html" %}
{% load static i18n %}

{% block content %}
  <div class="row">
    <div class="col">
      <p class="h1 text-center mt-4"><i class="bi-upc-scan"></i> {{ object.rescue_number }}</p>
    </div>
  </div>
  <div class="row">
    <div class="col">
      <table class="table">
        <thead>
          <tr>
            <th>{% translate 'name'|capfirst %}</th>
            {% if perms.artefacts.view_artefacttype %}
              <th>{% translate 'type'|capfirst %}</th>
            {% endif %}
            {% if perms.artefacts.view_prioritylevel %}
              <th>{% translate 'priority'|capfirst %}</th>
            {% endif %}
          </tr>
        </thead>
        <tbody>
         <tr>
            <td>
              {% if object.hazard %}<i class="bi {{ object.hazard.icon_class }} text-danger ms-2"></i>{% endif %}
              {% if object.composed_object %}<i class="bi {{ object.icon }} ms-2"></i>{% endif %}
              {{ object.name }}{% if object.inventory_number %} ({{ object.inventory_number }}){% endif %}</td>
            {% if perms.artefacts.view_artefacttype %}
              <td>{% if object.artefact_type %}{{ object.artefact_type }}{% endif %}</td>

              <td>{% if object.priority %}<span class="color-box" style="background-color:{{ object.priority.color }}"></span>{{ object.priority }}{% endif %}</td>
            {% endif %}
         </tr>
        </tbody>
      </table>
    </div>
  <div class="row mt-4">
    <div class="col">
      {% if measure.status == measure.IN_TREATMENT %}
        <p>
          <a href="{% url 'artefacts:finish-stabilization' pk=measure.pk %}" class="btn btn-warning btn-lg w-100">
            {% translate 'Finish stabilization measure : ' %} {{ measure.treatment_type }}
          </a>
        </p>
      {% elif measure.status != measure.FINISH %}
        <p>
          <a href="{% url 'artefacts:start-stabilization' pk=measure.pk processing_line_id=processing_line.pk %}" class="btn btn-success btn-lg w-100">
            {% translate 'Start process stabilization measures : ' %} {{ measure.treatment_type }}
          </a>
        </p>
      {% endif %}
      <p><a href="{{ object.get_absolute_url }}" class="btn btn-outline-secondary btn-lg w-100">{% translate 'View artefact' %}</a></p>
    </div>
  </div>
{% endblock content %}

diesos/templates/artefacts/artefacttype_form.html
{% extends "base.html" %}
{% load i18n %}
{% load crispy_forms_tags %}
{% block title %}{% translate "artefact type"|capfirst %}{% endblock %}
{% block content %}
  <div class="row">
    <div class="col">
        <h1>{{ title|capfirst }}</h1>
    </div>
  </div>
  <div class="row">
    <div class="col">
        <form method="post">
            {% csrf_token %}
            {{form|crispy}}
            <div class="d-flex justify-content-start mt-5">
              <a href="{% url 'artefacts:list-type' %}" class="btn btn-outline-secondary me-2"><i class="bi-x-lg"></i> {% translate "cancel"|capfirst %}</a>
              <button type="submit" class="btn btn-primary">{% translate "save"|capfirst %}</button>
            </div>
        </form>
    </div>
  </div>
</div>
{% endblock %}

diesos/templates/artefacts/artefacttype_list.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{% translate "artefact types"|capfirst %}{% endblock %}

{% block javascript %}
    {{ block.super }}
    <!-- jsDelivr :: Sortable :: Latest (https://www.jsdelivr.com/package/npm/sortablejs) -->
    <script src="https://cdn.jsdelivr.net/npm/sortablejs@latest/Sortable.min.js"></script>
{% endblock javascript %}

{% block content %}
  <div class="row">
    <div class="col">
      <h1>{% translate "artefact types"|capfirst %}</h1>
    </div>
  </div>
  <div class="row">
    <div class="col text-end">
      {% if perms.artefacts.add_artefacttype %}
        <a id="addButton" href="{% url 'artefacts:add-type' %}" class="btn btn-outline-primary ">{% translate "add"|capfirst %}</a>
      {%  endif %}
    </div>
  </div>
  <div class="row justify-content-center">
    <div class="col">
      {% if object_list %}
      <table class="table table-hover">
        <thead class="thead-light">
          <tr>
            <th class="updateDisplay"></th>
            <th>{% translate "type name"|capfirst %}</th>
            <th>{% translate "description"|capfirst %}</th>
            <th></th>
          </tr>
        </thead>
        <tbody id="types">
          {% for type in object_list %}
          <tr data-lookup="{{ type.id }}">
            <td class="updateDisplay"><i class="handle bi bi-list"></i></td>
            <td>{{type.type_name}}</td>
            <td><i>{{type.description}}</i></td>
            <td>
              <div class="d-flex justify-content-end">
                {% if perms.artefacts.change_artefacttype %}
                  <a href="{% url 'artefacts:change-type' type.id %}" class="btn-sm btn-outline-primary mx-1"><i class="bi bi-pencil"></i></a>
                {%  endif %}
                {% if perms.artefacts.delete_artefacttype %}
                  <a href="{% url 'artefacts:delete-type' type.id %}" class="btn-sm btn-outline-danger mx-1"><i class="bi bi-trash"></i></a>
                {%  endif %}
              </div>
            </td>
          </tr>
          {% endfor %}
        </tbody>
      </table>
      {% else %}
      <p class="text-center">{% translate "no artefact types saved"|capfirst %}</p>
      {% endif %}
      <form id="orderingForm" method="post" action="{% url 'artefacts:save-type-ordering' %}">
        {% csrf_token %}
      <input type="hidden" id="orderingInput" name="ordering">
    </form>
    </div>
  </div>
  <div class="row">
    <div class="col text-end">
      {% if perms.artefacts.change_artefacttype %}
        <a id="reorderModeButton" class="btn btn-outline-primary" onclick="toggleReorderMode();">{% translate "reorder"|capfirst %}</a>
        <a id="cancelButton" href="{% url 'artefacts:list-type' %}" class="btn btn-outline-secondary me-2" onclick="toggleReorderMode();" style="display:none;"><i class="bi-x-lg"></i> {% translate "cancel"|capfirst %}</a>
        <button id="saveOrdering" class="btn btn-outline-primary" style="display:none;">{% translate "save"|capfirst %}</button>
      {%  endif %}
    </div>
  </div>

{% block inline_javascript %}
<script>

<!--ReorderModeScript-->
  let reorder_mode = false;

  function toggleReorderMode() {
    reorder_mode = !reorder_mode;
    updateDisplay();
  }

  function updateDisplay() {
    document.getElementById('reorderModeButton').style.display = reorder_mode ? 'none' : 'inline-block';
    document.getElementById('cancelButton').style.display = reorder_mode ? 'inline-block' : 'none';
    document.getElementById('saveOrdering').style.display = reorder_mode ? 'inline-block' : 'none';

    const hiddenStuff = document.querySelectorAll('.updateDisplay');
      for (let hidden of hiddenStuff) {
        if (reorder_mode) {
          hidden.style.display = '';
        } else {
          hidden.style.display = 'none';
        }
    }
  }

  document.addEventListener('DOMContentLoaded', () => {
    updateDisplay();
  });


<!--DragAndDropScript-->
  const types = document.getElementById("types");
  const saveOrderingButton = document.getElementById('saveOrdering');
  const orderingForm = document.getElementById('orderingForm');
  const formInput = orderingForm.querySelector('#orderingInput');

  let sortable = Sortable.create(types, {
    handle: '.handle',
    dragClass: 'dragged',
    chosenClass: 'sortableChosen',});

  function saveOrdering() {
    const rows = document.getElementById("types").querySelectorAll('tr');
    let ids = [];
    for (let row of rows) {
        ids.push(row.dataset.lookup);
    }
    formInput.value = ids.join(',');
    orderingForm.submit();
}

saveOrderingButton.addEventListener('click', saveOrdering);


</script>
{% endblock inline_javascript %}

{% endblock %}

diesos/templates/artefacts/damagegroup_list.html
{% extends "base.html" %}
{% load i18n %}
{% block title %}{% translate "damage group"|capfirst %}{% endblock %}
{% block content %}
  <div class="row">
    <div class="col">
      <h1>{% translate "damage group"|capfirst %}</h1>
    </div>
  </div>
  <div class="row">
    <div class="col text-end">
      {% if perms.artefacts.add_damagegroup %}
        <a href="{% url 'artefacts:add-damage-group' %}" class="btn btn-outline-primary">{% translate "add"|capfirst %}</a>
      {% endif %}
    </div>
  </div>
  <div class="row">
    <div class="col">
      <table class="table table-hover">
        <thead>
          <tr>
            <th>{% translate 'name'|capfirst %}</th>
            <th class="w-25"></th>
          </tr>
        </thead>
        <tbody>
          {% for group in object_list %}
            <td>{{group.name}}</td>
            <td>
              <div class="d-flex justify-content-end">
                {% if perms.artefacts.change_damagegroup %}
                  <a href="{% url 'artefacts:change-damage-group' group.id %}" class="btn-sm btn-outline-primary mx-1"><i class="bi bi-pencil"></i></a>
                {%  endif %}
                {% if perms.artefacts.delete_damagegroup %}
                  <a href="{% url 'artefacts:delete-damage-group' group.id %}" class="btn-sm btn-outline-danger mx-1"><i class="bi bi-trash"></i></a>
                {%  endif %}
              </div>
            </td>
          </tr>
          {% endfor %}
        </tbody>
      </table>
    </div>
  </div>
{% endblock %}

diesos/templates/artefacts/existingcollection_edit_file_headers.html
{% extends "base.html" %}
{% load i18n %}
{% load crispy_forms_tags %}
{% block title %}{% translate "edit file headers"|capfirst %}{% endblock %}
{% block content %}
  <div class="row">
    <div class="col mb-3">
      <p>{% translate "you can edit headers names or skip this step"|capfirst %}</p>
        <div class="d-flex justify-content-start">
              <a href="{% url 'artefacts:import-file' %}" class="btn btn-outline-secondary me-2"><i class="bi-x-lg"></i> {% translate "cancel"|capfirst %}</a>
              <a href="{% url 'artefacts:map-existing-collection' %}" class="btn btn-primary me-2">{% translate "Skip this step"|capfirst %}</a>
        </div>
    </div>
  </div>
  <div class="row">
    <div class="col">
        <h1>{% translate "Headers name edition"|capfirst %}</h1>
    </div>
  </div>
  <div class="row">
    <div class="col">
        <form method="post">
            {% csrf_token %}
            {{form|crispy}}
            <div class="d-flex justify-content-start mt-5">
              <a href="{% url 'artefacts:import-file' %}" class="btn btn-outline-secondary me-2"><i class="bi-x-lg"></i> {% translate "cancel"|capfirst %}</a>
              <button type="submit" class="btn btn-primary">{% translate "save"|capfirst %}</button>
            </div>
        </form>
    </div>
  </div>
</div>
{% endblock %}

diesos/templates/artefacts/typeofdamage_list.html
{% extends "base.html" %}
{% load i18n %}
{% block title %}{% translate "damage type"|capfirst %}{% endblock %}
{% block content %}
  <div class="row">
    <div class="col">
      <h1>{% translate "damage type"|capfirst %}</h1>
    </div>
  </div>
  <div class="row">
    <div class="col text-end">
      {% if perms.artefacts.add_damagegroup %}
        <a href="{% url 'artefacts:add-damage-type' %}" class="btn btn-outline-primary">{% translate "add"|capfirst %}</a>
      {% endif %}
    </div>
  </div>
  <div class="row">
    <div class="col">
      <table class="table table-hover">
        <thead>
          <tr>
            <th></th>
            <th>{% translate 'name'|capfirst %}</th>
            <th class="w-25">{% translate 'group'|capfirst %}</th>
            <th>{% translate 'description'|capfirst %}</th>
            <th></th>
          </tr>
        </thead>
        <tbody>
          {% for type in object_list %}
            <td><i class="h1 {{type.icon_class}}"></i></td>
            <td>{{type.name}}</td>
            <td>{{type.group}}</td>
            <td>{{type.description}}</td>
            <td>
              <div class="d-flex justify-content-end">
                {% if perms.artefacts.change_typeofdamage %}
                  <a href="{% url 'artefacts:change-damage-type' type.id %}" class="btn-sm btn-outline-primary mx-1"><i class="bi bi-pencil"></i></a>
                {%  endif %}
                {% if perms.artefacts.delete_typeofdamage %}
                  <a href="{% url 'artefacts:delete-damage-type' type.id %}" class="btn-sm btn-outline-danger mx-1"><i class="bi bi-trash"></i></a>
                {%  endif %}
              </div>
            </td>
          </tr>
          {% endfor %}
        </tbody>
      </table>
    </div>
  </div>
{% endblock %}